#!/bin/bash

#==============全局变量定义 start=======================
#运行模块名
MODULE_NAME="kcs"
#定义环境变量
export GOPATH=/opt/gowww/kcs

MAIN_FILE="$GOPATH/app/main.go"
RUNTIME="$GOPATH/runtime"
BUILT_FILE="$GOPATH/app/${MODULE_NAME}"
LOG_FILE="$RUNTIME/run.log"
#保存pid的临时文件,可按情况进行修改，比如放到/run/passport.pid
PID_FILE="$RUNTIME/${MODULE_NAME}.pid"

#默认输出到控制台
RUN_COMMAND=${BUILT_FILE}

#if [ "$WITH_COVER" = "true" ]; then
#  BUILT_FILE=${BUILT_FILE}_c
#  RANDSTR=`date "+%s"`
#  RUN_COMMAND="${BUILT_FILE} -test.coverprofile ${RUNTIME}/kcs-${RANDSTR}.cov -test.run=TestKCS"
#fi

#==============全局变量定义 end=========================

#==============修改运行环境 start===================

init(){
	echo "==========init start==========="
	#运行环境
	runmode=$RUNMODE
	#http端口
	httpport=$HTTPPORT
	
	if [ "$runmode"x = ""x ]; then
	    runmode="prod"
	fi
	echo "runmode="$runmode
	sed -i "s/^runmode.*/runmode=$runmode/g"  $GOPATH/app/conf/app.conf
	
	if [ "$httpport"x != ""x ]; then
		echo "httpport="$httpport
	    sed -i "s/^httpport.*/httpport=$httpport/g"  $GOPATH/app/conf/app.conf
	fi
	
	#日志输出到哪里,2:指定的文件，3：文件和控制台，其它都输出控制台
	log2where=$LOG2WHERE
	
	if [ "$log2where"x = "2"x ]; then
	    RUN_COMMAND=${RUN_COMMAND}" > "${LOG_FILE}" 2>&1"
	elif [ "$log2where"x = "3"x ]; then
	    RUN_COMMAND=${RUN_COMMAND}" 2>&1 | tee -a "${LOG_FILE}
	else
	    RUN_COMMAND="${RUN_COMMAND} 2>&1"
	fi	
	echo "run command="$RUN_COMMAMD
	
	echo "==========init end============="
}

#==============修改运行环境 end======================
start(){
	echo "start $MODULE_NAME"

	if [ ! -e $BUILT_FILE ]; then
		echo "no built file: ${BUILT_FILE}. start fail"
		return 1
	fi

	if [ ! -e $LOG_FILE ]; then
		touch $LOG_FILE
	fi
	
	#检查PID文件是否存在
	if [ -e $PID_FILE ]
	then
		#检查PID是否正在运行
		pid=`cat $PID_FILE`
		res=`ps aux|awk -v pid=$pid '{if($2 == pid) {print $2}}'`
		if [ "$pid" = "$res" ] ;then
			echo "has pid file: $PID_FILE,pid=$pid, $MODULE_NAME already run."
			return 0
	    fi
	fi
	#echo $RUN_COMMAND
    eval $RUN_COMMAND

    if [ $? -ne 0 ] ;then            
        return 1
    fi
}

#创建运行目录 
create_runtime(){
	if [ ! -e $RUNTIME ]; then
		mkdir -p $RUNTIME
	fi
}

#check_private(){
#    if [ "$runmode"x = "private"x ]; then
#        mkdir -p $RUNTIME/config
#        mv $GOPATH/bin/kcs_private.conf.template $RUNTIME/config/kcs_private.conf
#        sed "s/^url_host=.*/url_host=$HOSTNAME:$HTTPPORT/g" -i $RUNTIME/config/kcs_private.conf
#        sed "s,^url_static=.*,url_static=$HOSTNAME:$HTTPPORT/static,g" -i $RUNTIME/config/kcs_private.conf
#        sed "s,^url_wapi=.*,url_wapi=$HOSTNAME:$HTTPPORT/ajax,g" -i $RUNTIME/config/kcs_private.conf
#    fi
#}

#==========================================
#执行命令
#==========================================
create_runtime
init
#check_private

#keep running
echo "DEBUG="$DEBUG
if [ "$DEBUG"x = "1"x ]; then
    exec "/bin/bash"
else
	start
fi
